


MCMC <- function(popdata,reps=1000,thinning=10,theta="gamma(1,1)",Fprior="uniform(0,1)")
  {
    ## void onelocusFMCMC(int *x, int *loc, int *n, int *reps, int *thinning, char **thetaprior
    ##	     char **Fprior, double *F, double *theta)
    if (class(popdata)=="table") {
      m <- as.data.frame(popdata)
      xx <- as.integer(rep(m[,1],m[,3]))-1
      location <- as.integer(rep(m[,2],m[,3]))-1
      print(data.frame(xx,location))
    } else {   
      xx <- as.integer(factor(popdata$x))-1
      location <- as.integer(factor(popdata$loc))-1
    }
    a <- .C("onelocusFMCMC"
            ,as.integer(xx)
            ,as.integer(location)
            ,as.integer(length(location))
            ,as.integer(reps)
            ,as.integer(thinning)
            ,as.character(theta)
            ,as.character(Fprior)
            ,resF=as.double(numeric(reps))
            ,rest=as.double(numeric(reps))
       )
    data.frame(theta=a$rest,F=a$resF)
  }
