



"impF" <- function(popdata,F=seq(0,0.8,0.01),driveF=0.1,nperms=10,theta=1)
  {
    ## void onelocusFimpll(int *x, int *loc, int *n, double *F, int *nF , double *drive
    ##		      , int *nperms, double *theta, double *ll)
    ## convert x and loc to a factor and then back to integer to assume they go from
    ## 1  
    
    if (inherits(popdata,"table")) {
      m <- as.data.frame(popdata)
      xx <- as.integer(rep(m[,1],m[,3]))-1
      location <- as.integer(rep(m[,2],m[,3]))-1
      #print(data.frame(xx,location))
    } else {   
      xx <- as.integer(factor(popdata$x))-1
      location <- as.integer(factor(popdata$loc))-1
    }
   
    a <- .C("onelocusFimpll"
       ,as.integer(xx)
       ,as.integer(location)
       ,as.integer(length(location))
       ,as.double(F)
       ,as.integer(length(F))
       ,as.double(driveF)
       ,as.integer(nperms)
       ,as.double(theta)
       ,res=as.double(numeric(length(F)))
       )
    a$res
  }


"mlF" <- function(popdata,nperms=10,seed=1,driveF=0.1,theta)
{
  tmp.seed <- .Random.seed
  if (inherits(popdata,"table")) {
    rownames(popdata) <- 1:nrow(popdata) # fix for as.table problem
    m <- as.data.frame(popdata)
    xx <- as.integer(rep(m[,1],m[,3]))-1
    location <- as.integer(rep(m[,2],m[,3]))-1
  } else {   
    xx <- as.integer(factor(popdata$x))-1
    location <- as.integer(factor(popdata$loc))-1
  }
  WeirFst <- WCFsta(table(xx,location))
  if (WeirFst<=0) WeirFst <- 0.00001
  if (missing(theta)) {
    f2 <- function(x) {
      if (x[1]<=0.00001||x[1]>=1) return(1E10)
      if (x[2]<=0) return(1E10) 
      set.seed(seed);
      return(
             -.C("onelocusFimpll"
                 ,as.integer(xx)
                 ,as.integer(location)
                 ,as.integer(length(location))
                 ,as.double(x[1])
                 ,as.integer(1)
                 ,as.double(driveF)
                 ,as.integer(nperms)
                 ,as.double(x[2])
                 ,as.double(numeric(1))
                 )[[9]]
             )
    }
    ret <- nlm(f2,c(WeirFst,1))
  } else {
    ## one dimensional minimisation
    f1 <- function(Fv) {
      set.seed(seed);
      if (Fv<=0.0) return(-1E100)
      return(
             .C("onelocusFimpll"
                ,as.integer(xx)
                ,as.integer(location)
                ,as.integer(length(location))
                ,as.double(Fv)
                ,as.integer(1)
                ,as.double(driveF)
                ,as.integer(nperms)
                ,as.double(theta)
                ,as.double(numeric(1))
                )[[9]]
             )
    }
    ret <- optimise(f1,interval=c(0.00001,.999999),maximum=TRUE)
  }
    .Random.seed <<- tmp.seed
    return(ret)
}


"mlFb" <- function(popdata,nperms=10,seed=1,driveF=0.1,theta)
{
  tmp.seed <- .Random.seed
  if (inherits(popdata,"table")) {
    m <- as.data.frame(popdata)
    xx <- as.integer(rep(m[,1],m[,3]))-1
    location <- as.integer(rep(m[,2],m[,3]))-1
  } else {   
    xx <- as.integer(factor(popdata$x))-1
    location <- as.integer(factor(popdata$loc))-1
  }
  npops <- max(location)+1;
    f2 <- function(x) {
      if (min(x)<=0.0) return(1E10)
      if(max(x)>=1.0) return(1E10)
      set.seed(seed);
      return(
             -.C("onelocusFimpllb"
                 ,as.integer(xx)
                 ,as.integer(location)
                 ,as.integer(length(location))
                 ,as.double(x)
                 ,as.double(driveF)
                 ,as.integer(nperms)
                 ,as.double(1.0)
                 ,as.double(numeric(1))
                 )[[8]]
             )
    }
  ret <- nlm(f2,rep(0.1,npops))
  .Random.seed <<- tmp.seed
  return(ret)
}
