"mcmcFst" <-
function(m,steps=100,burnin=100,thinning=10)
{
  ## likelihood function
  lmnall <- function(localth,localp) {
    ## mnDirichlet for a single row
    lmnDirichlet <- function(x) {
      lt <- lgamma(x+localth*localp)-lgamma(x+1)-lgamma(localth*localp)
      lgamma(localth)-lgamma(localth+sum(x)) + sum(lt)
    }
    sum(apply(m,1,lmnDirichlet))
  }
  ## the mcmc function
  Fstupdate <- function(len,sttheta) {
    currth <- sttheta
    ll <- lmnall(currth,currp)
    for (i in 1:steps) {
      trytheta <- rnorm(1,currth,1)
      if (trytheta<0) trytheta <- -trytheta
      tryll <- lmnall(trytheta,currp)
      a <- exp(tryll-ll)
      if (runif(1)<a) {     
        currth <- trytheta
        ll <- tryll
      }
      ## now try to change p
      up <- sample(k,2)      
      nwp <- currp
      smp <- sum(currp[up])
      nwp[up[1]] <- runif(1,0,smp)
      nwp[up[2]] <- smp-nwp[up[1]]
      tryll <- lmnall(currth,nwp)
      a <- exp(tryll-ll)
      if (runif(1)<a) {
        currp <- nwp
        ll <- tryll
      }
    }
    currth
  }
  currp <- apply(m,2,sum)/sum(m)
  k <- length(currp)
  theta <- numeric(steps)
  theta[1] <- Fstupdate(burnin,9) 

  for (i in 2:steps) {
    theta[i] <- Fstupdate(thinning,theta[i-1])
  }
  1/(1+theta)  
}

