## convert Genomic Haplotype data to a single locus
"onelocus" <- function(gendata)
  {
    r <- data.frame(x=factor(apply(gendata$d,1,paste,sep="",collapse="")),loc=gendata$location)
    class(r) <- c("onelocus","data.frame")
    r
  }
## print a summary of onelocus data
"print.onelocus" <- function(a)
  {
    print(table(a))
  }

## convert Genomic Haplotype data to a single locus as a single table
"onelocustab" <- function(gendata)
  {
    table(factor(apply(gendata$d,1,paste,sep="",collapse="")),loc=gendata$location)
  }

## convert Genomic Haplotype data to a single locus
"multilocus" <- function(gendata,len=1,overlap=0)
  {
    extractHAP <- function(st) {
      factor(apply(gendata$d[,c(st:(st+len-1))],1,paste,sep="",collapse=""))
    }
    nSNP <- ncol(gendata$d)
    start <- seq(1,(nSNP-len+1),(len-overlap))
    if (len>1) 
      x <- data.frame(lapply(start,extractHAP))
    else x <- data.frame(gendata$d)
    colnames(x) <- paste("a",start,sep="")
    r <- list(x=x,location=gendata$location)  
    class(r) <- c("multilocus")
    r
  }
## print a summary of multilocus data
print.multilocus <- function(a)
  {
    print(cbind(a$x,a$location))
  }
