\name{impF}
\alias{impF}

\title{ Calculate the likelihood of a sample under a combined inbreeding ESF model.}
\description{
  Calculate the likelihood of a sample under an inbreeding model using
  importance sampling.
}
\usage{
impF(popdata, F = seq(0, 0.8, 0.01), driveF = 0.1, nperms = 10, theta = 1)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{popdata}{ Population data of class \code{\link{onelocus}}}
  \item{F}{ A vector of inbreeding coefficients (equal F for each population) }
  \item{driveF}{ The driving value for F }
  \item{nperms}{ The number of permutations to average over }
  \item{theta}{The theta parameter for mutations }
}
\details{
  ~~ If necessary, more details than the description above ~~
}
\value{
  A vector of likelihoods with length equal to the number of F values given.
}
\references{\link{http://www.mas.ncl.ac.uk/~/nijw}}
\author{ Ian Wilson \email{I.J.Wilson@ncl.ac.uk}}
\note{ ~~further notes~~ 

 ~Make other sections like Warning with \section{Warning }{....} ~
}
\seealso{ \code{\link{mlF}},\code{\link{onelocus}} }
\examples{
Fst <- seq(0,0.5,0.01)
plot(Fst,impF(subdiv1,Fst,theta=4),type="l",axes=F,xlab=expression(F[ST]),ylab="Likelihood")
axis(1);axis(2)
}
\keyword{ distribution }% at least one, from doc/KEYWORDS

