#ifndef ONELOCUSF_H__
#define ONELOCUSF_H__

#include <vector>
#include <string>
#include <iostream>
#include "tnt/tnt.h"
#include "gsl_rand.H"

/** This class is a one locus version of the pac model for subdivided
    population, as a proof on concept that this works as well as Fst say */
class onelocusF {
public:
  onelocusF(const std::vector<std::string> &a
	,const TNT::Array1D<int> &loc);

  onelocusF(int *a, int *loc, int len);
  
  double likelihood(double theta);
  double likelihood(double thet, bool *gg);
  // likelihood when F = 0 
  double likelihoodF0(double theta);
  double likelihoodresampleg(double *F, double theta,bool *g,double &lpsamp); 
 
  double resampleg(double *F,rng &r);
  double lpsampleg(double *F);

  double resampleg_b(double *F,double theta,rng &r);
  double lpsampleg_b(double *F,double theta);
  double lpg(double *F);
  
  void perm(rng &r) {
    permute(&order[0],n,r);
  }

  double lpg(double *F, bool *gg);
  // data
  TNT::Array1D<int>  x;           
  TNT::Array1D<int>  location; 
  int n,k,npops;
  // auxilary parameters
  TNT::Array1D<bool> g_;          // global?
  TNT::Array1D<int> order;        // the ordering of data
};

TNT::Array1D<int> convdata1(const std::vector<std::string> &a);

#endif
